Index: src/builder.cpp
===================================================================
--- src/builder.cpp	(revision 6056f1f6a543f7dbfa9dde0b7705d6820addf1c4)
+++ src/builder.cpp	(revision 6cd16bc4b2635b48c1eb855a13b887a00af82259)
@@ -50,4 +50,7 @@
 using namespace std;
 
+#include <cstring>
+
+#include "analysis_bonds.hpp"
 #include "analysis_correlation.hpp"
 #include "atom.hpp"
@@ -65,4 +68,6 @@
 #include "molecule.hpp"
 #include "periodentafel.hpp"
+#include "version.h"
+#include "World.hpp"
 
 /********************************************* Subsubmenu routine ************************************/
@@ -81,24 +86,24 @@
   bool valid;
 
-  Log() << Verbose(0) << "===========ADD ATOM============================" << endl;
-  Log() << Verbose(0) << " a - state absolute coordinates of atom" << endl;
-  Log() << Verbose(0) << " b - state relative coordinates of atom wrt to reference point" << endl;
-  Log() << Verbose(0) << " c - state relative coordinates of atom wrt to already placed atom" << endl;
-  Log() << Verbose(0) << " d - state two atoms, two angles and a distance" << endl;
-  Log() << Verbose(0) << " e - least square distance position to a set of atoms" << endl;
-  Log() << Verbose(0) << "all else - go back" << endl;
-  Log() << Verbose(0) << "===============================================" << endl;
-  Log() << Verbose(0) << "Note: Specifiy angles in degrees not multiples of Pi!" << endl;
-  Log() << Verbose(0) << "INPUT: ";
+  cout << Verbose(0) << "===========ADD ATOM============================" << endl;
+  cout << Verbose(0) << " a - state absolute coordinates of atom" << endl;
+  cout << Verbose(0) << " b - state relative coordinates of atom wrt to reference point" << endl;
+  cout << Verbose(0) << " c - state relative coordinates of atom wrt to already placed atom" << endl;
+  cout << Verbose(0) << " d - state two atoms, two angles and a distance" << endl;
+  cout << Verbose(0) << " e - least square distance position to a set of atoms" << endl;
+  cout << Verbose(0) << "all else - go back" << endl;
+  cout << Verbose(0) << "===============================================" << endl;
+  cout << Verbose(0) << "Note: Specifiy angles in degrees not multiples of Pi!" << endl;
+  cout << Verbose(0) << "INPUT: ";
   cin >> choice;
 
   switch (choice) {
     default:
-      Log() << Verbose(0) << "Not a valid choice." << endl;
+      DoeLog(2) && (eLog()<< Verbose(2) << "Not a valid choice." << endl);
       break;
       case 'a': // absolute coordinates of atom
-        Log() << Verbose(0) << "Enter absolute coordinates." << endl;
+        cout << Verbose(0) << "Enter absolute coordinates." << endl;
         first = new atom;
-        first->x.AskPosition(mol->cell_size, false);
+        first->x.AskPosition(World::get()->cell_size, false);
         first->type = periode->AskElement();  // give type
         mol->AddAtom(first);  // add to molecule
@@ -109,11 +114,11 @@
         valid = true;
         do {
-          if (!valid) Log() << Verbose(0) << "Resulting position out of cell." << endl;
-          Log() << Verbose(0) << "Enter reference coordinates." << endl;
-          x.AskPosition(mol->cell_size, true);
-          Log() << Verbose(0) << "Enter relative coordinates." << endl;
-          first->x.AskPosition(mol->cell_size, false);
+          if (!valid) DoeLog(2) && (eLog()<< Verbose(2) << "Resulting position out of cell." << endl);
+          cout << Verbose(0) << "Enter reference coordinates." << endl;
+          x.AskPosition(World::get()->cell_size, true);
+          cout << Verbose(0) << "Enter relative coordinates." << endl;
+          first->x.AskPosition(World::get()->cell_size, false);
           first->x.AddVector((const Vector *)&x);
-          Log() << Verbose(0) << "\n";
+          cout << Verbose(0) << "\n";
         } while (!(valid = mol->CheckBounds((const Vector *)&first->x)));
         first->type = periode->AskElement();  // give type
@@ -125,8 +130,8 @@
         valid = true;
         do {
-          if (!valid) Log() << Verbose(0) << "Resulting position out of cell." << endl;
+          if (!valid) DoeLog(2) && (eLog()<< Verbose(2) << "Resulting position out of cell." << endl);
           second = mol->AskAtom("Enter atom number: ");
-          Log() << Verbose(0) << "Enter relative coordinates." << endl;
-          first->x.AskPosition(mol->cell_size, false);
+          DoLog(0) && (Log() << Verbose(0) << "Enter relative coordinates." << endl);
+          first->x.AskPosition(World::get()->cell_size, false);
           for (int i=NDIM;i--;) {
             first->x.x[i] += second->x.x[i];
@@ -142,9 +147,7 @@
         do {
           if (!valid) {
-            Log() << Verbose(0) << "Resulting coordinates out of cell - ";
-            first->x.Output();
-            Log() << Verbose(0) << endl;
+            DoeLog(2) && (eLog()<< Verbose(2) << "Resulting coordinates out of cell - " << first->x << endl);
           }
-          Log() << Verbose(0) << "First, we need two atoms, the first atom is the central, while the second is the outer one." << endl;
+          cout << Verbose(0) << "First, we need two atoms, the first atom is the central, while the second is the outer one." << endl;
           second = mol->AskAtom("Enter central atom: ");
           third = mol->AskAtom("Enter second atom (specifying the axis for first angle): ");
@@ -157,5 +160,5 @@
           c *= M_PI/180.;
           bound(&c, -M_PI, M_PI);
-          Log() << Verbose(0) << "radius: " << a << "\t phi: " << b*180./M_PI << "\t theta: " << c*180./M_PI << endl;
+          cout << Verbose(0) << "radius: " << a << "\t phi: " << b*180./M_PI << "\t theta: " << c*180./M_PI << endl;
 /*
           second->Output(1,1,(ofstream *)&cout);
@@ -169,10 +172,10 @@
 
           if (!z.SolveSystem(&x,&y,&n, b, c, a)) {
-            Log() << Verbose(0) << "Failure solving self-dependent linear system!" << endl;
+         coutg() << Verbose(0) << "Failure solving self-dependent linear system!" << endl;
             continue;
           }
-          Log() << Verbose(0) << "resulting relative coordinates: ";
+          DoLog(0) && (Log() << Verbose(0) << "resulting relative coordinates: ");
           z.Output();
-          Log() << Verbose(0) << endl;
+          DoLog(0) && (Log() << Verbose(0) << endl);
           */
           // calc axis vector
@@ -182,13 +185,13 @@
           Log() << Verbose(0) << "x: ",
           x.Output();
-          Log() << Verbose(0) << endl;
+          DoLog(0) && (Log() << Verbose(0) << endl);
           z.MakeNormalVector(&second->x,&third->x,&fourth->x);
           Log() << Verbose(0) << "z: ",
           z.Output();
-          Log() << Verbose(0) << endl;
+          DoLog(0) && (Log() << Verbose(0) << endl);
           y.MakeNormalVector(&x,&z);
           Log() << Verbose(0) << "y: ",
           y.Output();
-          Log() << Verbose(0) << endl;
+          DoLog(0) && (Log() << Verbose(0) << endl);
 
           // rotate vector around first angle
@@ -197,5 +200,5 @@
           Log() << Verbose(0) << "Rotated vector: ",
           first->x.Output();
-          Log() << Verbose(0) << endl;
+          DoLog(0) && (Log() << Verbose(0) << endl);
           // remove the projection onto the rotation plane of the second angle
           n.CopyVector(&y);
@@ -203,18 +206,18 @@
           Log() << Verbose(0) << "N1: ",
           n.Output();
-          Log() << Verbose(0) << endl;
+          DoLog(0) && (Log() << Verbose(0) << endl);
           first->x.SubtractVector(&n);
           Log() << Verbose(0) << "Subtracted vector: ",
           first->x.Output();
-          Log() << Verbose(0) << endl;
+          DoLog(0) && (Log() << Verbose(0) << endl);
           n.CopyVector(&z);
           n.Scale(first->x.ScalarProduct(&z));
           Log() << Verbose(0) << "N2: ",
           n.Output();
-          Log() << Verbose(0) << endl;
+          DoLog(0) && (Log() << Verbose(0) << endl);
           first->x.SubtractVector(&n);
           Log() << Verbose(0) << "2nd subtracted vector: ",
           first->x.Output();
-          Log() << Verbose(0) << endl;
+          DoLog(0) && (Log() << Verbose(0) << endl);
 
           // rotate another vector around second angle
@@ -223,5 +226,5 @@
           Log() << Verbose(0) << "2nd Rotated vector: ",
           n.Output();
-          Log() << Verbose(0) << endl;
+          DoLog(0) && (Log() << Verbose(0) << endl);
 
           // add the two linear independent vectors
@@ -231,7 +234,7 @@
           first->x.AddVector(&second->x);
 
-          Log() << Verbose(0) << "resulting coordinates: ";
+          DoLog(0) && (Log() << Verbose(0) << "resulting coordinates: ");
           first->x.Output();
-          Log() << Verbose(0) << endl;
+          DoLog(0) && (Log() << Verbose(0) << endl);
         } while (!(valid = mol->CheckBounds((const Vector *)&first->x)));
         first->type = periode->AskElement();  // give type
@@ -246,7 +249,7 @@
           atoms[i] = NULL;
         int i=0, j=0;
-        Log() << Verbose(0) << "Now we need at least three molecules.\n";
+        cout << Verbose(0) << "Now we need at least three molecules.\n";
         do {
-          Log() << Verbose(0) << "Enter " << i+1 << "th atom: ";
+          cout << Verbose(0) << "Enter " << i+1 << "th atom: ";
           cin >> j;
           if (j != -1) {
@@ -263,5 +266,5 @@
         } else {
           delete first;
-          Log() << Verbose(0) << "Please enter at least two vectors!\n";
+          cout << Verbose(0) << "Please enter at least two vectors!\n";
         }
         break;
@@ -277,30 +280,30 @@
   char choice;  // menu choice char
 
-  Log() << Verbose(0) << "===========CENTER ATOMS=========================" << endl;
-  Log() << Verbose(0) << " a - on origin" << endl;
-  Log() << Verbose(0) << " b - on center of gravity" << endl;
-  Log() << Verbose(0) << " c - within box with additional boundary" << endl;
-  Log() << Verbose(0) << " d - within given simulation box" << endl;
-  Log() << Verbose(0) << "all else - go back" << endl;
-  Log() << Verbose(0) << "===============================================" << endl;
-  Log() << Verbose(0) << "INPUT: ";
+  cout << Verbose(0) << "===========CENTER ATOMS=========================" << endl;
+  cout << Verbose(0) << " a - on origin" << endl;
+  cout << Verbose(0) << " b - on center of gravity" << endl;
+  cout << Verbose(0) << " c - within box with additional boundary" << endl;
+  cout << Verbose(0) << " d - within given simulation box" << endl;
+  cout << Verbose(0) << "all else - go back" << endl;
+  cout << Verbose(0) << "===============================================" << endl;
+  cout << Verbose(0) << "INPUT: ";
   cin >> choice;
 
   switch (choice) {
     default:
-      Log() << Verbose(0) << "Not a valid choice." << endl;
+      cout << Verbose(0) << "Not a valid choice." << endl;
       break;
     case 'a':
-      Log() << Verbose(0) << "Centering atoms in config file on origin." << endl;
+      cout << Verbose(0) << "Centering atoms in config file on origin." << endl;
       mol->CenterOrigin();
       break;
     case 'b':
-      Log() << Verbose(0) << "Centering atoms in config file on center of gravity." << endl;
+      cout << Verbose(0) << "Centering atoms in config file on center of gravity." << endl;
       mol->CenterPeriodic();
       break;
     case 'c':
-      Log() << Verbose(0) << "Centering atoms in config file within given additional boundary." << endl;
+      cout << Verbose(0) << "Centering atoms in config file within given additional boundary." << endl;
       for (int i=0;i<NDIM;i++) {
-        Log() << Verbose(0) << "Enter axis " << i << " boundary: ";
+        cout << Verbose(0) << "Enter axis " << i << " boundary: ";
         cin >> y.x[i];
       }
@@ -313,7 +316,7 @@
       break;
     case 'd':
-      Log() << Verbose(1) << "Centering atoms in config file within given simulation box." << endl;
+      cout << Verbose(1) << "Centering atoms in config file within given simulation box." << endl;
       for (int i=0;i<NDIM;i++) {
-        Log() << Verbose(0) << "Enter axis " << i << " boundary: ";
+        cout << Verbose(0) << "Enter axis " << i << " boundary: ";
         cin >> x.x[i];
       }
@@ -336,12 +339,12 @@
   char choice;  // menu choice char
 
-  Log() << Verbose(0) << "===========ALIGN ATOMS=========================" << endl;
-  Log() << Verbose(0) << " a - state three atoms defining align plane" << endl;
-  Log() << Verbose(0) << " b - state alignment vector" << endl;
-  Log() << Verbose(0) << " c - state two atoms in alignment direction" << endl;
-  Log() << Verbose(0) << " d - align automatically by least square fit" << endl;
-  Log() << Verbose(0) << "all else - go back" << endl;
-  Log() << Verbose(0) << "===============================================" << endl;
-  Log() << Verbose(0) << "INPUT: ";
+  cout << Verbose(0) << "===========ALIGN ATOMS=========================" << endl;
+  cout << Verbose(0) << " a - state three atoms defining align plane" << endl;
+  cout << Verbose(0) << " b - state alignment vector" << endl;
+  cout << Verbose(0) << " c - state two atoms in alignment direction" << endl;
+  cout << Verbose(0) << " d - align automatically by least square fit" << endl;
+  cout << Verbose(0) << "all else - go back" << endl;
+  cout << Verbose(0) << "===============================================" << endl;
+  cout << Verbose(0) << "INPUT: ";
   cin >> choice;
 
@@ -356,6 +359,6 @@
       break;
     case 'b': // normal vector of mirror plane
-      Log() << Verbose(0) << "Enter normal vector of mirror plane." << endl;
-      n.AskPosition(mol->cell_size,0);
+      cout << Verbose(0) << "Enter normal vector of mirror plane." << endl;
+      n.AskPosition(World::get()->cell_size,0);
       n.Normalize();
       break;
@@ -376,5 +379,5 @@
         fscanf(stdin, "%3s", shorthand);
       } while ((param.type = periode->FindElement(shorthand)) == NULL);
-      Log() << Verbose(0) << "Element is " << param.type->name << endl;
+      cout << Verbose(0) << "Element is " << param.type->name << endl;
       mol->GetAlignvector(&param);
       for (int i=NDIM;i--;) {
@@ -383,13 +386,13 @@
       }
       gsl_vector_free(param.x);
-      Log() << Verbose(0) << "Offset vector: ";
+      cout << Verbose(0) << "Offset vector: ";
       x.Output();
-      Log() << Verbose(0) << endl;
+      DoLog(0) && (Log() << Verbose(0) << endl);
       n.Normalize();
       break;
   };
-  Log() << Verbose(0) << "Alignment vector: ";
+  DoLog(0) && (Log() << Verbose(0) << "Alignment vector: ");
   n.Output();
-  Log() << Verbose(0) << endl;
+  DoLog(0) && (Log() << Verbose(0) << endl);
   mol->Align(&n);
 };
@@ -404,11 +407,11 @@
   char choice;  // menu choice char
 
-  Log() << Verbose(0) << "===========MIRROR ATOMS=========================" << endl;
-  Log() << Verbose(0) << " a - state three atoms defining mirror plane" << endl;
-  Log() << Verbose(0) << " b - state normal vector of mirror plane" << endl;
-  Log() << Verbose(0) << " c - state two atoms in normal direction" << endl;
-  Log() << Verbose(0) << "all else - go back" << endl;
-  Log() << Verbose(0) << "===============================================" << endl;
-  Log() << Verbose(0) << "INPUT: ";
+  DoLog(0) && (Log() << Verbose(0) << "===========MIRROR ATOMS=========================" << endl);
+  DoLog(0) && (Log() << Verbose(0) << " a - state three atoms defining mirror plane" << endl);
+  DoLog(0) && (Log() << Verbose(0) << " b - state normal vector of mirror plane" << endl);
+  DoLog(0) && (Log() << Verbose(0) << " c - state two atoms in normal direction" << endl);
+  DoLog(0) && (Log() << Verbose(0) << "all else - go back" << endl);
+  DoLog(0) && (Log() << Verbose(0) << "===============================================" << endl);
+  DoLog(0) && (Log() << Verbose(0) << "INPUT: ");
   cin >> choice;
 
@@ -423,6 +426,6 @@
       break;
     case 'b': // normal vector of mirror plane
-      Log() << Verbose(0) << "Enter normal vector of mirror plane." << endl;
-      n.AskPosition(mol->cell_size,0);
+      DoLog(0) && (Log() << Verbose(0) << "Enter normal vector of mirror plane." << endl);
+      n.AskPosition(World::get()->cell_size,0);
       n.Normalize();
       break;
@@ -436,7 +439,7 @@
       break;
   };
-  Log() << Verbose(0) << "Normal vector: ";
+  DoLog(0) && (Log() << Verbose(0) << "Normal vector: ");
   n.Output();
-  Log() << Verbose(0) << endl;
+  DoLog(0) && (Log() << Verbose(0) << endl);
   mol->Mirror((const Vector *)&n);
 };
@@ -452,11 +455,11 @@
   char choice;  // menu choice char
 
-  Log() << Verbose(0) << "===========REMOVE ATOMS=========================" << endl;
-  Log() << Verbose(0) << " a - state atom for removal by number" << endl;
-  Log() << Verbose(0) << " b - keep only in radius around atom" << endl;
-  Log() << Verbose(0) << " c - remove this with one axis greater value" << endl;
-  Log() << Verbose(0) << "all else - go back" << endl;
-  Log() << Verbose(0) << "===============================================" << endl;
-  Log() << Verbose(0) << "INPUT: ";
+  DoLog(0) && (Log() << Verbose(0) << "===========REMOVE ATOMS=========================" << endl);
+  DoLog(0) && (Log() << Verbose(0) << " a - state atom for removal by number" << endl);
+  DoLog(0) && (Log() << Verbose(0) << " b - keep only in radius around atom" << endl);
+  DoLog(0) && (Log() << Verbose(0) << " c - remove this with one axis greater value" << endl);
+  DoLog(0) && (Log() << Verbose(0) << "all else - go back" << endl);
+  DoLog(0) && (Log() << Verbose(0) << "===============================================" << endl);
+  DoLog(0) && (Log() << Verbose(0) << "INPUT: ");
   cin >> choice;
 
@@ -465,11 +468,11 @@
     case 'a':
       if (mol->RemoveAtom(mol->AskAtom("Enter number of atom within molecule: ")))
-        Log() << Verbose(1) << "Atom removed." << endl;
+        DoLog(1) && (Log() << Verbose(1) << "Atom removed." << endl);
       else
-        Log() << Verbose(1) << "Atom not found." << endl;
+        DoLog(1) && (Log() << Verbose(1) << "Atom not found." << endl);
       break;
     case 'b':
       second = mol->AskAtom("Enter number of atom as reference point: ");
-      Log() << Verbose(0) << "Enter radius: ";
+      DoLog(0) && (Log() << Verbose(0) << "Enter radius: ");
       cin >> tmp1;
       first = mol->start;
@@ -483,9 +486,9 @@
       break;
     case 'c':
-      Log() << Verbose(0) << "Which axis is it: ";
+      DoLog(0) && (Log() << Verbose(0) << "Which axis is it: ");
       cin >> axis;
-      Log() << Verbose(0) << "Lower boundary: ";
+      DoLog(0) && (Log() << Verbose(0) << "Lower boundary: ");
       cin >> tmp1;
-      Log() << Verbose(0) << "Upper boundary: ";
+      DoLog(0) && (Log() << Verbose(0) << "Upper boundary: ");
       cin >> tmp2;
       first = mol->start;
@@ -517,20 +520,20 @@
   char choice;  // menu choice char
 
-  Log() << Verbose(0) << "===========MEASURE ATOMS=========================" << endl;
-  Log() << Verbose(0) << " a - calculate bond length between one atom and all others" << endl;
-  Log() << Verbose(0) << " b - calculate bond length between two atoms" << endl;
-  Log() << Verbose(0) << " c - calculate bond angle" << endl;
-  Log() << Verbose(0) << " d - calculate principal axis of the system" << endl;
-  Log() << Verbose(0) << " e - calculate volume of the convex envelope" << endl;
-  Log() << Verbose(0) << " f - calculate temperature from current velocity" << endl;
-  Log() << Verbose(0) << " g - output all temperatures per step from velocities" << endl;
-  Log() << Verbose(0) << "all else - go back" << endl;
-  Log() << Verbose(0) << "===============================================" << endl;
-  Log() << Verbose(0) << "INPUT: ";
+  DoLog(0) && (Log() << Verbose(0) << "===========MEASURE ATOMS=========================" << endl);
+  DoLog(0) && (Log() << Verbose(0) << " a - calculate bond length between one atom and all others" << endl);
+  DoLog(0) && (Log() << Verbose(0) << " b - calculate bond length between two atoms" << endl);
+  DoLog(0) && (Log() << Verbose(0) << " c - calculate bond angle" << endl);
+  DoLog(0) && (Log() << Verbose(0) << " d - calculate principal axis of the system" << endl);
+  DoLog(0) && (Log() << Verbose(0) << " e - calculate volume of the convex envelope" << endl);
+  DoLog(0) && (Log() << Verbose(0) << " f - calculate temperature from current velocity" << endl);
+  DoLog(0) && (Log() << Verbose(0) << " g - output all temperatures per step from velocities" << endl);
+  DoLog(0) && (Log() << Verbose(0) << "all else - go back" << endl);
+  DoLog(0) && (Log() << Verbose(0) << "===============================================" << endl);
+  DoLog(0) && (Log() << Verbose(0) << "INPUT: ");
   cin >> choice;
 
   switch(choice) {
     default:
-      Log() << Verbose(1) << "Not a valid choice." << endl;
+      DoLog(1) && (Log() << Verbose(1) << "Not a valid choice." << endl);
       break;
     case 'a':
@@ -564,11 +567,11 @@
       x.SubtractVector((const Vector *)&second->x);
       tmp1 = x.Norm();
-      Log() << Verbose(1) << "Distance vector is ";
+      DoLog(1) && (Log() << Verbose(1) << "Distance vector is ");
       x.Output();
-      Log() << Verbose(0) << "." << endl << "Norm of distance is " << tmp1 << "." << endl;
+      DoLog(0) && (Log() << Verbose(0) << "." << endl << "Norm of distance is " << tmp1 << "." << endl);
       break;
 
     case 'c':
-      Log() << Verbose(0) << "Evaluating bond angle between three - first, central, last - atoms." << endl;
+      DoLog(0) && (Log() << Verbose(0) << "Evaluating bond angle between three - first, central, last - atoms." << endl);
       first = mol->AskAtom("Enter first atom: ");
       second = mol->AskAtom("Enter central atom: ");
@@ -579,10 +582,10 @@
       y.CopyVector((const Vector *)&third->x);
       y.SubtractVector((const Vector *)&second->x);
-      Log() << Verbose(0) << "Bond angle between first atom Nr." << first->nr << ", central atom Nr." << second->nr << " and last atom Nr." << third->nr << ": ";
-      Log() << Verbose(0) << (acos(x.ScalarProduct((const Vector *)&y)/(y.Norm()*x.Norm()))/M_PI*180.) << " degrees" << endl;
+      DoLog(0) && (Log() << Verbose(0) << "Bond angle between first atom Nr." << first->nr << ", central atom Nr." << second->nr << " and last atom Nr." << third->nr << ": ");
+      DoLog(0) && (Log() << Verbose(0) << (acos(x.ScalarProduct((const Vector *)&y)/(y.Norm()*x.Norm()))/M_PI*180.) << " degrees" << endl);
       break;
     case 'd':
-      Log() << Verbose(0) << "Evaluating prinicipal axis." << endl;
-      Log() << Verbose(0) << "Shall we rotate? [0/1]: ";
+      DoLog(0) && (Log() << Verbose(0) << "Evaluating prinicipal axis." << endl);
+      DoLog(0) && (Log() << Verbose(0) << "Shall we rotate? [0/1]: ");
       cin >> Z;
       if ((Z >=0) && (Z <=1))
@@ -593,5 +596,5 @@
     case 'e':
       {
-        Log() << Verbose(0) << "Evaluating volume of the convex envelope.";
+        DoLog(0) && (Log() << Verbose(0) << "Evaluating volume of the convex envelope.");
         class Tesselation *TesselStruct = NULL;
         const LinkedCell *LCList = NULL;
@@ -599,5 +602,5 @@
         FindConvexBorder(mol, TesselStruct, LCList, NULL);
         double clustervolume = VolumeOfConvexEnvelope(TesselStruct, configuration);
-        Log() << Verbose(0) << "The tesselated surface area is " << clustervolume << "." << endl;\
+        DoLog(0) && (Log() << Verbose(0) << "The tesselated surface area is " << clustervolume << "." << endl);\
         delete(LCList);
         delete(TesselStruct);
@@ -610,12 +613,12 @@
       {
         char filename[255];
-        Log() << Verbose(0) << "Please enter filename: " << endl;
+        DoLog(0) && (Log() << Verbose(0) << "Please enter filename: " << endl);
         cin >> filename;
-        Log() << Verbose(1) << "Storing temperatures in " << filename << "." << endl;
+        DoLog(1) && (Log() << Verbose(1) << "Storing temperatures in " << filename << "." << endl);
         ofstream *output = new ofstream(filename, ios::trunc);
         if (!mol->OutputTemperatureFromTrajectories(output, 0, mol->MDSteps))
-          Log() << Verbose(2) << "File could not be written." << endl;
+          DoLog(2) && (Log() << Verbose(2) << "File could not be written." << endl);
         else
-          Log() << Verbose(2) << "File stored." << endl;
+          DoLog(2) && (Log() << Verbose(2) << "File stored." << endl);
         output->close();
         delete(output);
@@ -634,6 +637,6 @@
   clock_t start, end;
 
-  Log() << Verbose(0) << "Fragmenting molecule with current connection matrix ..." << endl;
-  Log() << Verbose(0) << "What's the desired bond order: ";
+  DoLog(0) && (Log() << Verbose(0) << "Fragmenting molecule with current connection matrix ..." << endl);
+  DoLog(0) && (Log() << Verbose(0) << "What's the desired bond order: ");
   cin >> Order1;
   if (mol->first->next != mol->last) {  // there are bonds
@@ -641,7 +644,7 @@
     mol->FragmentMolecule(Order1, configuration);
     end = clock();
-    Log() << Verbose(0) << "Clocks for this operation: " << (end-start) << ", time: " << ((double)(end-start)/CLOCKS_PER_SEC) << "s." << endl;
+    DoLog(0) && (Log() << Verbose(0) << "Clocks for this operation: " << (end-start) << ", time: " << ((double)(end-start)/CLOCKS_PER_SEC) << "s." << endl);
   } else
-    Log() << Verbose(0) << "Connection matrix has not yet been generated!" << endl;
+    DoLog(0) && (Log() << Verbose(0) << "Connection matrix has not yet been generated!" << endl);
 };
 
@@ -654,5 +657,5 @@
 static void ManipulateAtoms(periodentafel *periode, MoleculeListClass *molecules, config *configuration)
 {
-  atom *first, *second;
+  atom *first, *second, *third;
   molecule *mol = NULL;
   Vector x,y,z,n; // coordinates for absolute point in cell volume
@@ -662,20 +665,21 @@
   bool valid;
 
-  Log() << Verbose(0) << "=========MANIPULATE ATOMS======================" << endl;
-  Log() << Verbose(0) << "a - add an atom" << endl;
-  Log() << Verbose(0) << "r - remove an atom" << endl;
-  Log() << Verbose(0) << "b - scale a bond between atoms" << endl;
-  Log() << Verbose(0) << "u - change an atoms element" << endl;
-  Log() << Verbose(0) << "l - measure lengths, angles, ... for an atom" << endl;
-  Log() << Verbose(0) << "all else - go back" << endl;
-  Log() << Verbose(0) << "===============================================" << endl;
+  DoLog(0) && (Log() << Verbose(0) << "=========MANIPULATE ATOMS======================" << endl);
+  DoLog(0) && (Log() << Verbose(0) << "a - add an atom" << endl);
+  DoLog(0) && (Log() << Verbose(0) << "r - remove an atom" << endl);
+  DoLog(0) && (Log() << Verbose(0) << "b - scale a bond between atoms" << endl);
+  DoLog(0) && (Log() << Verbose(0) << "t - turn an atom round another bond" << endl);
+  DoLog(0) && (Log() << Verbose(0) << "u - change an atoms element" << endl);
+  DoLog(0) && (Log() << Verbose(0) << "l - measure lengths, angles, ... for an atom" << endl);
+  DoLog(0) && (Log() << Verbose(0) << "all else - go back" << endl);
+  DoLog(0) && (Log() << Verbose(0) << "===============================================" << endl);
   if (molecules->NumberOfActiveMolecules() > 1)
-    Log() << Verbose(0) << "WARNING: There is more than one molecule active! Atoms will be added to each." << endl;
-  Log() << Verbose(0) << "INPUT: ";
+    DoeLog(2) && (eLog()<< Verbose(2) << "There is more than one molecule active! Atoms will be added to each." << endl);
+  DoLog(0) && (Log() << Verbose(0) << "INPUT: ");
   cin >> choice;
 
   switch (choice) {
     default:
-      Log() << Verbose(0) << "Not a valid choice." << endl;
+      DoLog(0) && (Log() << Verbose(0) << "Not a valid choice." << endl);
       break;
 
@@ -684,5 +688,5 @@
         if ((*ListRunner)->ActiveFlag) {
         mol = *ListRunner;
-        Log() << Verbose(0) << "Current molecule is: " << mol->IndexNr << "\t" << mol->name << endl;
+        DoLog(0) && (Log() << Verbose(0) << "Current molecule is: " << mol->IndexNr << "\t" << mol->name << endl);
         AddAtoms(periode, mol);
       }
@@ -693,6 +697,6 @@
         if ((*ListRunner)->ActiveFlag) {
         mol = *ListRunner;
-        Log() << Verbose(0) << "Current molecule is: " << mol->IndexNr << "\t" << mol->name << endl;
-        Log() << Verbose(0) << "Scaling bond length between two atoms." << endl;
+        DoLog(0) && (Log() << Verbose(0) << "Current molecule is: " << mol->IndexNr << "\t" << mol->name << endl);
+        DoLog(0) && (Log() << Verbose(0) << "Scaling bond length between two atoms." << endl);
         first = mol->AskAtom("Enter first (fixed) atom: ");
         second = mol->AskAtom("Enter second (shifting) atom: ");
@@ -701,6 +705,6 @@
           minBond += (first->x.x[i]-second->x.x[i])*(first->x.x[i] - second->x.x[i]);
         minBond = sqrt(minBond);
-        Log() << Verbose(0) << "Current Bond length between " << first->type->name << " Atom " << first->nr << " and " << second->type->name << " Atom " << second->nr << ": " << minBond << " a.u." << endl;
-        Log() << Verbose(0) << "Enter new bond length [a.u.]: ";
+        DoLog(0) && (Log() << Verbose(0) << "Current Bond length between " << first->type->name << " Atom " << first->nr << " and " << second->type->name << " Atom " << second->nr << ": " << minBond << " a.u." << endl);
+        DoLog(0) && (Log() << Verbose(0) << "Enter new bond length [a.u.]: ");
         cin >> bond;
         for (int i=NDIM;i--;) {
@@ -716,7 +720,7 @@
         if ((*ListRunner)->ActiveFlag) {
         mol = *ListRunner;
-        Log() << Verbose(0) << "Current molecule is: " << mol->IndexNr << "\t" << mol->name << endl;
-       Log() << Verbose(0) << "Angstroem -> Bohrradius: 1.8897261\t\tBohrradius -> Angstroem: 0.52917721" << endl;
-       Log() << Verbose(0) << "Enter three factors: ";
+        DoLog(0) && (Log() << Verbose(0) << "Current molecule is: " << mol->IndexNr << "\t" << mol->name << endl);
+       DoLog(0) && (Log() << Verbose(0) << "Angstroem -> Bohrradius: 1.8897261\t\tBohrradius -> Angstroem: 0.52917721" << endl);
+       DoLog(0) && (Log() << Verbose(0) << "Enter three factors: ");
        factor = new double[NDIM];
        cin >> factor[0];
@@ -733,5 +737,5 @@
         if ((*ListRunner)->ActiveFlag) {
         mol = *ListRunner;
-        Log() << Verbose(0) << "Current molecule is: " << mol->IndexNr << "\t" << mol->name << endl;
+        DoLog(0) && (Log() << Verbose(0) << "Current molecule is: " << mol->IndexNr << "\t" << mol->name << endl);
         MeasureAtoms(periode, mol, configuration);
       }
